errors = {}
options = {}
macro_ops = {}
stages = {}
svcid = 22
SUCCESS = 0
WARNING = 1
ERROR = 2
def determine_severity(msgs):
    severity = SUCCESS
    if msgs and len(msgs) > 0:
        for msg in msgs:
            severity = max(severity, msg[0])
    return severity
def determine_action_severity(list):
    severity = SUCCESS
    if list and len(list) > 0:
        for action in list:
            severity = max(severity, determine_severity(action[2]))
    return severity
def get_option_from_code(code, options_table):
    index = (code >> 48) & 0xff
    return options_table.get(index, None)
def get_errornum_from_code(code):
    return (code >> 56) & 0xff
options[0] = "dbaseadmin"; dbaseadmin = 0L
options[1] = "dbasenum"; dbasenum = 1L
options[2] = "dbaseprefix"; dbaseprefix = 2L
ADMIN_BLANK = (22L << 56) | (dbaseadmin << 48) | 0; errors[(22L << 56) | (dbaseadmin << 48) | 0] = "The database user can not be left blank."
USER_EXISTS = (22L << 56) | (dbaseadmin << 48) | 1; errors[(22L << 56) | (dbaseadmin << 48) | 1] = "This database user name is already in use. Please select another user name."
ADMIN_ROOT = (22L << 56) | (dbaseadmin << 48) | 2; errors[(22L << 56) | (dbaseadmin << 48) | 2] = "The database user name can not be root, mysql, or wpphpadmin."
INVALID_ADMIN = (22L << 56) | (dbaseadmin << 48) | 3; errors[(22L << 56) | (dbaseadmin << 48) | 3] = "Invalid database user name."
ADMIN_NAME_LOWER = (22L << 56) | (dbaseadmin << 48) | 4; errors[(22L << 56) | (dbaseadmin << 48) | 4] = "Upper case letters in database user name %(dbaseadmin)s were converted to lower case."
ADMIN_NAME_BADCHARS = (22L << 56) | (dbaseadmin << 48) | 5; errors[(22L << 56) | (dbaseadmin << 48) | 5] = "Grant: The database user name %(dbaseadmin)s contains invalid characters: %(badchars)s"
DB_NAME_BADCHARS = (22L << 56) | (dbaseadmin << 48) | 6; errors[(22L << 56) | (dbaseadmin << 48) | 6] = "The database name %(dbaseadmin)s contains invalid characters: %(badchars)s "
DBASE_LIMIT_NAN = (22L << 56) | (dbasenum << 48) | 7; errors[(22L << 56) | (dbasenum << 48) | 7] = "The maximum number of databases is not a number."
MYSQL_DBASENUM_LESS_THAN_0 = (22L << 56) | (dbasenum << 48) | 8; errors[(22L << 56) | (dbasenum << 48) | 8] = "The number of mysql databases specified is negative. Please specify positive number or zero for unlimited databases."
PREFIX_NAME_BADCHARS = (22L << 56) | (dbaseprefix << 48) | 9; errors[(22L << 56) | (dbaseprefix << 48) | 9] = "The database prefix %(dbaseprefix)s contains invalid characters: %(badchars)s "
MYSQL_USER_EXISTS = (22L << 56) | (dbaseadmin << 48) | 10; errors[(22L << 56) | (dbaseadmin << 48) | 10] = "The database user name is already in use, although it is not associated with a site. Please choose another name."
INVALID_PREFIX = (22L << 56) | (dbaseprefix << 48) | 11; errors[(22L << 56) | (dbaseprefix << 48) | 11] = "Invalid database prefix."
PREFIX_TOO_LONG = (22L << 56) | (dbaseprefix << 48) | 12; errors[(22L << 56) | (dbaseprefix << 48) | 12] = "The database prefix, if marked as having been mangled (i.e. begins with a '_'), can not be longer than 36 characters. If not marked as mangled, it may not be longer than 33 characters."
PREFIX_EXISTS = (22L << 56) | (dbaseprefix << 48) | 14; errors[(22L << 56) | (dbaseprefix << 48) | 14] = "MySQL Prefix Exists. Please enter another Prefix"
UNABLE_TO_MANGLE_USER = (22L << 56) | (dbaseadmin << 48) | 15; errors[(22L << 56) | (dbaseadmin << 48) | 15] = "Could not find an unused MySQL user name similar to the existing name."
MANGLED_USER = (22L << 56) | (dbaseadmin << 48) | 16; errors[(22L << 56) | (dbaseadmin << 48) | 16] = "In order to create a unique MySQL user name, the original user name %(origuser)s was converted to %(newuser)s. Please have the site administrator update his or her applications as necessary."
UNABLE_TO_MANGLE_PREFIX = (22L << 56) | (dbaseprefix << 48) | 17; errors[(22L << 56) | (dbaseprefix << 48) | 17] = "Could not find an unused database prefix similar to the existing prefix."
MANGLED_PREFIX = (22L << 56) | (dbaseprefix << 48) | 18; errors[(22L << 56) | (dbaseprefix << 48) | 18] = "In order to create a unique MySQL database prefix, the original prefix %(origprefix)s was converted to %(newprefix)s. Any existing databases belonging to the site whose names began with the original prefix will have been renamed so that they now begin with the new prefix. Please have the site administrator update his or her applications as necessary."
PLAN_MAY_NOT_SET_PREFIX = (22L << 56) | (dbaseprefix << 48) | 19; errors[(22L << 56) | (dbaseprefix << 48) | 19] = "You may not specify a database prefix in a plan definition."
PLAN_MAY_NOT_SET_ADMIN = (22L << 56) | (dbaseadmin << 48) | 20; errors[(22L << 56) | (dbaseadmin << 48) | 20] = "You may not specify a database administrator in a plan definition."
PREFIXED_DB_TOO_LONG = (22L << 56) | (dbaseprefix << 48) | 21; errors[(22L << 56) | (dbaseprefix << 48) | 21] = "If the prefix %(prefix)s was applied to existing database %(db)s, the resulting name would be too long."
GRANT_MYSQL_FAILED = ((22L << 56) | (255L << 48)) | 1; errors[((22L << 56) | (255L << 48)) | 1] = "Failed to grant permissions on database %(dbasename)s: %(reason)s"
REVOKE_MYSQL_FAILED = ((22L << 56) | (255L << 48)) | 2; errors[((22L << 56) | (255L << 48)) | 2] = "Failed to revoke permissions on  database %(dbasename)s: %(reason)s"
DISABLE_MYSQL_FAILED = ((22L << 56) | (255L << 48)) | 3; errors[((22L << 56) | (255L << 48)) | 3] = "Failed to drop database %(dbasename)s: %(reason)s"
ENABLE_MYSQL_FAILED = ((22L << 56) | (255L << 48)) | 4; errors[((22L << 56) | (255L << 48)) | 4] = "Failed to create database %(dbasename)s: %(reason)s"
RENAME_MYSQL_FAILED = ((22L << 56) | (255L << 48)) | 5; errors[((22L << 56) | (255L << 48)) | 5] = "Failed to rename database to %(dbasename)s: %(reason)s"
INSTALL_MYSQL_FAILED = ((22L << 56) | (255L << 48)) | 6; errors[((22L << 56) | (255L << 48)) | 6] = "Failed to install mysql."
RECONFIGURE_MYSQL_FAILED = ((22L << 56) | (255L << 48)) | 7; errors[((22L << 56) | (255L << 48)) | 7] = "Failed to reconfigure permissions on database %(dbasename)s: %(reason)s"
MYSQL_DB_EXISTS = ((22L << 56) | (255L << 48)) | 8; errors[((22L << 56) | (255L << 48)) | 8] = "The database %(db)s already exists."
MYSQL_DBS_NAN = ((22L << 56) | (255L << 48)) | 9; errors[((22L << 56) | (255L << 48)) | 9] = "The allocated number database is not a number."
MYSQL_MAX_DBS = ((22L << 56) | (255L << 48)) | 10; errors[((22L << 56) | (255L << 48)) | 10] = "Mysql Database creation limit exceeded"
MYSQL_ERROR = ((22L << 56) | (255L << 48)) | 11; errors[((22L << 56) | (255L << 48)) | 11] = "Mysql error: %(mysqlerr)s"
MYSQL_DB_REDUCED = ((22L << 56) | (255L << 48)) | 12; errors[((22L << 56) | (255L << 48)) | 12] = "The number of databases that a site admin can create are being reduced. This will stop site admin from creating any more databases."
MYSQL_QUOTA_FAILED = ((22L << 56) | (255L << 48)) | 13; errors[((22L << 56) | (255L << 48)) | 13] = "Failed to apply Quota.: %(reason)s"
MYSQL_DBASENUM_0 = ((22L << 56) | (255L << 48)) | 15; errors[((22L << 56) | (255L << 48)) | 15] = "Number of mysql databases specified is zero. This will not allow the site admin to create any databases."
MYSQL_PREFIX_CHANGED = ((22L << 56) | (255L << 48)) | 16; errors[((22L << 56) | (255L << 48)) | 16] = "You have changed the database prefix. This may have changed the name of some or all of the site databases, as a result of which, your site will be unable to connect to its databases.\n\n To restore database connections, do one of the following:\n 1. Revert to the original prefix\n 2. Edit code references to the site databases so as to update the old prefix with the new prefix."
MYSQL_RESTORE_DB_RENAME = ((22L << 56) | (255L << 48)) | 17; errors[((22L << 56) | (255L << 48)) | 17] = "WEBppliance can not restore the database, as the database already exists. Hence restoring the database %(dbasename)s as _%(num)s%(dbasename)s. To restore database connection, you will have to edit code references to the site databases or will have to restore the site on another server that does not use the database name."
MYSQL_RESTORE_FAILED = ((22L << 56) | (255L << 48)) | 18; errors[((22L << 56) | (255L << 48)) | 18] = "MySQL restore failed. Problem while linking the database directory"
MYSQL_EXPORT_METADATA_FAILED = ((22L << 56) | (255L << 48)) | 19; errors[((22L << 56) | (255L << 48)) | 19] = "Could not add the database name, database administrator and database administrator password to tar file."
MYSQL_EXPORT_REMOVE_MYSQLDBLIST_FAILED = ((22L << 56) | (255L << 48)) | 20; errors[((22L << 56) | (255L << 48)) | 20] = "Could not remove mysql directories from the list. This may cause a problem while restoring the data."
MYSQL_EXPORT_CLEANUP_FAILED = ((22L << 56) | (255L << 48)) | 21; errors[((22L << 56) | (255L << 48)) | 21] = "Export Cleanup failed. Reason: %(reason)s. Please delete the file %(dmpfile)s"
MYSQL_RESTORE_DB_FAILED = ((22L << 56) | (255L << 48)) | 22; errors[((22L << 56) | (255L << 48)) | 22] = "Could not restore '%(dbasename)s': %(reason)s . You will be able to recover the databases from /var/lib/mysql/%(dbasename)s.mysql.dmp"
MYSQL_RESTORE_PREFIX_MANGLED = ((22L << 56) | (255L << 48)) | 23; errors[((22L << 56) | (255L << 48)) | 23] = "MySQL prefix changed %(domain)s to %(newprefix)s. This has changed the name of all the site databases, as a result of which, your site will be unable to connect to its databases.\n\n To restore database connections, do one of the following:\n 1. Edit code references to the site databases so as to update the old prefix with the new prefix. 2. Restore the site on other server where the prefix is free."
MYSQL_RESTORE_DBADMIN_MANGLED = ((22L << 56) | (255L << 48)) | 24; errors[((22L << 56) | (255L << 48)) | 24] = "Database admin for %(domain)s already exists. This has changed the name of the database administrator, as a result of which, your site will be unable to connect to its databases.\n\n To restore database connections, do one of the following:\n 1. Edit code references to the site databases so as to update the old database admin with the new database admin. 2. Restore the site on other server where the database administrator name is free."
PREFIX_NAME_MAY_EXISTS = ((22L << 56) | (255L << 48)) | 26; errors[((22L << 56) | (255L << 48)) | 26] = "The prefix entered is similar to a prefix already present. The other site may be able to create a database as this site. Changing the prefix is recomended."
MYSQL_LOGIN_ERROR = ((22L << 56) | (255L << 48)) | 27; errors[((22L << 56) | (255L << 48)) | 27] = "<br>Connection has failed due to one of the following reasons.<br>1) MySQL is running but authentication has failed. Please change the MySQL password: Subscribed Services > MySQL > Change MySQL Password.<br>2) MySQL is not running. Please start MySQL."
MYSQL_BACKUP_FAILED = ((22L << 56) | (255L << 48)) | 28; errors[((22L << 56) | (255L << 48)) | 28] = "MySQL backup failed. Reason: %(reason)s."
MYSQL_DBASENUM_LESS_THAN_0 = ((22L << 56) | (255L << 48)) | 29; errors[((22L << 56) | (255L << 48)) | 29] = "Number of mysql databases specified is negative. Please specify positive number or zero for unlimited databases."
GROUPADD = ((22L << 56) | (255L << 48)) | 30; errors[((22L << 56) | (255L << 48)) | 30] = "Failed to add mysql group in site filesystem."
USERADD = ((22L << 56) | (255L << 48)) | 31; errors[((22L << 56) | (255L << 48)) | 31] = "Failed to add mysql user in site filesystem."
UNKNOWN_ADMIN = ((22L << 56) | (255L << 48)) | 32; errors[((22L << 56) | (255L << 48)) | 32] = "Could not resolve the top-level administrative user %(admin)s for site."
DB_NAME_BADCHARS = ((22L << 56) | (255L << 48)) | 33; errors[((22L << 56) | (255L << 48)) | 33] = "The database name %(database)s contains characters from the set %(badchars)s, which are not allowed."
MYSQL_DB_RENAMED = ((22L << 56) | (255L << 48)) | 34; errors[((22L << 56) | (255L << 48)) | 34] = "The database %(db)s has been renamed to %(new_db)s."
MYSQL_IMPORTED_DB_RENAMED = ((22L << 56) | (255L << 48)) | 35; errors[((22L << 56) | (255L << 48)) | 35] = "The imported database %(db)s has been renamed to %(new_db)s."
DID_NOT_RESTORE_DB = ((22L << 56) | (255L << 48)) | 36; errors[((22L << 56) | (255L << 48)) | 36] = "The database %(db)s was not restored since MySQL is disabled for this site."
NOT_OUR_DATABASE = ((22L << 56) | (255L << 48)) | 37; errors[((22L << 56) | (255L << 48)) | 37] = "The database %(db)s already exists on this server, but does not belong to the importing site."
COULD_NOT_LINK_SOCK_FILE = ((22L << 56) | (255L << 48)) | 38; errors[((22L << 56) | (255L << 48)) | 38] = "The mysql.sock file could not be hard-linked to site %(site)s"
